models/Noticias.php
<?php

namespace app\models;

use yii\base\Model;

class Noticias extends Model {

    // Propiedades
    public string $title;
    public string $link;
    public string $description;
    
    // Los labels (etiquetas) que quiero que muestren los widget
    public function attributeLabels() {
        return [
            "title" => "Título",
            "link" => "Enlace",
            "description" => "Descripción",
        ];
    }
    
    public function rules(): array {
        return [
         // Para poder usar la asignacion masiva las propiedades tienen que ser seguras
          [['title','description','link'],'safe']  
        ];
    }
        
    
    
    // Metodo para crear un enlace con un boton
    public function crearEnlace(){
        return \yii\helpers\Html::a(
                "Ver noticia",
                $this->link,
                ["class" => "btn btn-primary"]
        );
    }
    
    // Metodo para poner la imagen de un XML
    public function crearImagen() {
        return str_replace(
                "src",
                'class="img-thumbnail" src',
                $this->description
                );
        
    }
    public function getEnlace(){
        return \yii\helpers\Html::a(
                "Ver noticia",
                $this->link,
                ["class" => "btn btn-primary"]
        );
    }
    
    public function getDescripcion() {
        return str_replace(
                "src",
                'class="img-thumbnail" src',
                $this->description
                );
        
    }
    
    
}

controllers/SiteController.php
<?php

namespace app\controllers;

use Yii;
use yii\filters\AccessControl;
use yii\web\Controller;
use yii\web\Response;
use yii\filters\VerbFilter;
use app\models\LoginForm;
use app\models\ContactForm;
use yii\data\ArrayDataProvider;

class SiteController extends Controller
{
    /**
     * {@inheritdoc}
     */
    public function behaviors()
    {
        return [
            'access' => [
                'class' => AccessControl::className(),
                'only' => ['logout'],
                'rules' => [
                    [
                        'actions' => ['logout'],
                        'allow' => true,
                        'roles' => ['@'],
                    ],
                ],
            ],
            'verbs' => [
                'class' => VerbFilter::className(),
                'actions' => [
                    'logout' => ['post'],
                ],
            ],
        ];
    }

    /**
     * {@inheritdoc}
     */
    public function actions()
    {
        return [
            'error' => [
                'class' => 'yii\web\ErrorAction',
            ],
            'captcha' => [
                'class' => 'yii\captcha\CaptchaAction',
                'fixedVerifyCode' => YII_ENV_TEST ? 'testme' : null,
            ],
        ];
    }

    /**
     * Displays homepage.
     *
     * @return string
     */
    public function actionIndex() {
        
        $vectorNoticias= $this->leerNoticias("https://www.eldiariomontanes.es/rss/2.0/?section=ultima-hora");
        
        // vamos a mostrar todas las noticias en un GRIDVIEW
        $dataProvider= new ArrayDataProvider([
            "allModels"=> $vectorNoticias,
            // Paginacion de 10 en 10 (hay que hacerlo en el Data Provider)
            'pagination' => [
                'pageSize' => 10
            ],
        ]);
        //var_dump($noticias);
        return $this->render('index',[
            "dataProvider" => $dataProvider,
            "titulo" => "Noticias de última hora",
            
        ]);
    }

    
     public function actionCine() {
        $vectorNoticias= $this->leerNoticias("https://www.eldiariomontanes.es/rss/2.0/?section=butaca/cine");
        
        // vamos a mostrar todas las noticias en un GRIDVIEW
        $dataProvider= new ArrayDataProvider([
            "allModels"=> $vectorNoticias,
            // Paginacion de 10 en 10 (hay que hacerlo en el Data Provider)
            'pagination' => [
                'pageSize' => 10
            ],
        ]);
        //var_dump($noticias);
        return $this->render('index',[
            "dataProvider" => $dataProvider,
            "titulo" => "Cine",
            
        ]);
    }
    
    public function actionRecetas() {
        // usamos el metodo que hemos creado abajo
        $vectorNoticias= $this->leerNoticias("https://www.eldiariomontanes.es/rss/2.0/?section=cantabria-mesa/recetas");
         
        
        // vamos a mostrar todas las noticias en un GRIDVIEW
        $dataProvider= new ArrayDataProvider([
            "allModels"=> $vectorNoticias,
            // Paginacion de 10 en 10 (hay que hacerlo en el Data Provider)
            'pagination' => [
                'pageSize' => 10
            ],
        ]);
        //var_dump($noticias);
        return $this->render('index',[
            "dataProvider" => $dataProvider,
            "titulo" => "Recetas",
            
        ]);
    }
    /**
     * Creamos un metodo que te pasan una url y te devuelve un array con las noticias de dicho url
     * @param type $url Es la direccion del servidor RSS
     * @return \app\models\Noticias()
     */
    
    private function leerNoticias ($url){
                
        // Leer una página web
        $contenido = file_get_contents($url);
        //var_dump($contenido);
        // funcion de php que convierte un xml a un objeto
        // en channel->item es donde estan las noticias
        // Esto te daría todas las noticias pero solo te devuelve la primera
        $objetoXML=simplexml_load_string($contenido)->channel->item;
        
        
        // Clonamos el objeto a nuestro modelo
        foreach ($objetoXML as $noticia) {
            // Noticia es un objeto de tipo XMLElement
            
            // ObjetoMioNoticia es un modelo, es un objeto creado a partir de la clase Noticias
            $objetoMioNoticia = new \app\models\Noticias();
            // sin utilizar asignacion masiva
//            $ObjetoMioNoticia->title=$noticia->title;
//            $ObjetoMioNoticia->link=$noticia->link;
//            $ObjetoMioNoticia->description=$noticia->description;
            
            // Con asignacion masiva
            $objetoMioNoticia->attributes=(array)$noticia; // hacemos un cast para convetir el objeto a un array
            
            // Me voy creando un array con objetos de tipo Noticias
            $vectorNoticias[]=$objetoMioNoticia;
        }
        return $vectorNoticias;
    }

    
}

views/layouts/main.php
<?php

/* @var $this \yii\web\View */
/* @var $content string */

use app\assets\AppAsset;
use app\widgets\Alert;
use yii\bootstrap4\Breadcrumbs;
use yii\bootstrap4\Html;
use yii\bootstrap4\Nav;
use yii\bootstrap4\NavBar;

AppAsset::register($this);
?>
<?php $this->beginPage() ?>
<!DOCTYPE html>
<html lang="<?= Yii::$app->language ?>" class="h-100">
<head>
    <meta charset="<?= Yii::$app->charset ?>">
    <meta name="viewport" content="width=device-width, initial-scale=1, shrink-to-fit=no">
    <?php $this->registerCsrfMetaTags() ?>
    <title><?= Html::encode($this->title) ?></title>
    <?php $this->head() ?>
</head>
<body class="d-flex flex-column h-100">
<?php $this->beginBody() ?>

<header>
    <?php
    NavBar::begin([
        'brandLabel' => Yii::$app->name,
        'brandUrl' => Yii::$app->homeUrl,
        'options' => [
            'class' => 'navbar navbar-expand-md navbar-dark bg-dark fixed-top',
        ],
    ]);
    echo Nav::widget([
        'options' => ['class' => 'navbar-nav'],
        'items' => [
            ['label' => 'Noticias última hora', 'url' => ['/site/index']],
            ['label' => 'Recetas', 'url' => ['/site/recetas']],
            ['label' => 'Cine', 'url' => ['/site/cine']],
            
        ],
    ]);
    NavBar::end();
    ?>
</header>

<main role="main" class="flex-shrink-0">
    <div class="container">
        <?= Breadcrumbs::widget([
            'links' => isset($this->params['breadcrumbs']) ? $this->params['breadcrumbs'] : [],
        ]) ?>
        <?= Alert::widget() ?>
        <?= $content ?>
    </div>
</main>

<footer class="footer mt-auto py-3 text-muted">
    <div class="container">
        <p class="float-left">&copy; My Company <?= date('Y') ?></p>
        <p class="float-right"><?= Yii::powered() ?></p>
    </div>
</footer>

<?php $this->endBody() ?>
</body>
</html>
<?php $this->endPage() ?>

views/site/error.php
<?php

/* @var $this yii\web\View */
/* @var $name string */
/* @var $message string */
/* @var $exception Exception */

use yii\helpers\Html;

$this->title = $name;
?>
<div class="site-error">

    <h1><?= Html::encode($this->title) ?></h1>

    <div class="alert alert-danger">
        <?= nl2br(Html::encode($message)) ?>
    </div>

    <p>
        The above error occurred while the Web server was processing your request.
    </p>
    <p>
        Please contact us if you think this is a server error. Thank you.
    </p>

</div>

views/site/index.php
<?php

/* @var $this yii\web\View */

$this->title = $titulo;
?>
<div class="site-index">

    <div class="jumbotron text-center bg-transparent">
        <h1 class="display-4"><?= $this->title?></h1>

    </div>

    <?= 
    \yii\grid\GridView::widget([
        "dataProvider" => $dataProvider,
        "columns" => [
            
            "title", // colocando directamente una propiedad del modelo
            // colocar un metodo del modelo
            [
                'label' => 'Enlace',
                'content' => function ($model){
                    return $model->crearEnlace();
                } 
            ],
            // colocar un metodo del modelo
            [
                'label' => 'Imagen',
                'content' => function ($model){
                   return $model->crearImagen();
                }
            ],
            // colocar un getter del modelo
            [
                'attribute'=> 'enlace', // como no encuentra la propiedad enlace (porque no existe) llama al getter que hemos creado
                'format'=> 'raw',
            ],
            [
                'attribute' => 'descripcion', // igual que en el enlace llamamos al getter llamado descripcion
                'format' => 'raw',
            ]
        ]
    ]);
    ?>
</div>